/*
 * @Author: vegawong
 * @Date:   2015-12-28 09:38:06
 * @Last Modified by:   vegawong
 * @Last Modified time: 2015-12-28 10:16:41
 */

'use strict';
var gulp = require('gulp');
var gutil = require('gulp-util');
var webpack = require('webpack');

gulp.task('build.prod.less', function() {
    gulp.src(['./src/less/**/*.less'])
        .pipe(gulp.dest('./less'));
});



gulp.task('build.prod.js', function(callback) {
    var wpConfig = require('./webpack.config.prod');
    // create optimizations array
    var optimizations = [
        new webpack.optimize.DedupePlugin(),
        new webpack.optimize.UglifyJsPlugin({
            output: {
                comments: false,
            },
            compress: {
                warnings: false,
            },
        }),
    ];
    if (wpConfig.plugins) {
        wpConfig.plugins = wpConfig.plugins.concat(optimizations);
    } else {
        wpConfig.plugins = optimizations;
    }
    // run webpack
    webpack(wpConfig, function(err, stats) {
        if (err) {
            throw new gutil.PluginError('webpack', err);
        }
        // only log when errors
        gutil.log('[webpack]: ', stats.toString({
            chunks: false,
            modules: false,
            colors: true,
        }));
        callback();
    });
});

gulp.task('build.prod', ['build.prod.less', 'build.prod.js']);
