/**
* @Author: Jet.Chan
* @Date:   2016-05-30T11:41:36+08:00
* @Email:  guanjie.chen@talebase.com
* @Last modified by:   Jet.Chan
* @Last modified time: 2017-03-13T18:15:08+08:00
*/



/*
    复选框
*/
'use strict';

require('./style.less');

var $ = require('jquery');
var stapes = require('stapes');
var util = require('../../../lib/util');

/*$(function() {
    if (util.ie <= 8) {
        $('div.cui-checkboxContainer').find('label i').append($('<span>'));
        $('div.cui-checkboxContainer').find('input').css({visibility:'visible', outline:'none'});
    }

    var checkboxes = $('div.cui-checkboxContainer');
    checkboxes.map(function(i, v) {
        var hash = new Date().getTime() + Math.random();
        $(v).find('input').attr('id', hash);
        $(v).find('label').attr('for', hash);

        if (!$(v).find('input').attr('checked')) {
            $(v).find('input').val('off');
        }
    }, this);

    $('div.cui-checkboxContainer input').on('click', function() {
        var val = $(this).val() === 'on' ? 'off' : 'on';
        $(this).val(val);
    });
});

module.exports = {
    getValue: function(ref) {
        var checkbox = $('div.cui-checkboxContainer[data-ref=' + ref + ']');
        var val = checkbox.find('input').val() === 'on' ? true : false;
        return val;
    },
    setValue: function(ref, val) {
        var checkbox = $('div.cui-checkboxContainer[data-ref=' + ref + ']');
        var value = checkbox.find('input').val() === 'on' ? true : false;
        if (value !== val) {
            checkbox.find('input').click();
        }
    }
};*/

var checkbox = stapes.subclass({
    constructor: function($el) {
        var self = this;

        if (!$el) {
            return;
        }
        self.$el = $el;
        self.val = true;

        self.init();
    },
    init: function() {
        var self = this;

        if (util.ie <= 8) {
            self.$el.find('label i').append($('<span>'));
            self.$el.find('input').css({
                visibility: 'visible',
                outline: 'none'
            });
        }

        var hash = new Date().getTime() + (Math.random() * Math.random());

        if (self.$el.find('input').attr('id') && self.$el.find('label').attr('for') && self.$el.find('input').attr('id') == self.$el.find('label').attr('for')){
            hash = self.$el.find('input').attr('id')
        }

        self.$el.find('input').attr('id', hash);
        self.$el.find('label').attr('for', hash);

        if (!self.$el.find('input').attr('checked')) {
            self.val = false;
        }

        self.watch();
    },
    watch: function() {
        var self = this;

        self.$el.find('input').on('click', function() {
            self.val = !self.val;
        });
    },
    getValue: function() {
        var self = this;

        return self.val;
    },
    setValue: function(val) {
        var self = this;

        if (self.val !== val) {
            self.$el.find('input').click();
        }
    }
});

module.exports = checkbox;
