/*
 * @Author: vegawong
 * @Date:   2015-12-17 14:58:49
 * @Last Modified by:   vega
 * @Last Modified time: 2016-01-21 17:11:37
 */

'use strict';

var $ = require('jquery');

/**
 * lazyLoad the img src
 * @param  {object} el the func's scrope,default:$('body')
 * @return {[type]}    [description]
 */
var lazyLoad = function(el) {
    var $el = el || $('body');
    $el.find('img').each(function(k, v) {
        var _src = $(v).data('src');
        if (_src) {
            var imgIntance = new Image();
            imgIntance.src = _src;
            imgIntance.onload = function() {
                $(v).attr('src', _src);
                $(v)[0].removeAttribute('data-src');
            }
        }
    });
};



module.exports = lazyLoad;
