/**
 * @Author: vegawong
 * @Date:   2016-02-20T14:44:07+08:00
 * @Last modified by:   vegawong
 * @Last modified time: 2016-02-20T16:10:04+08:00
 */



/*
    模态框
*/
'use strict';

require('./style.less');

var $ = require('jquery');
var stapes = require('stapes');

var modal = stapes.subclass({
    constructor: function($broken, $el) {
        var self = this;
        if (!$el || !$broken) {
            return;
        }

        self.$el = $el;
        self.$broken = $broken;
        self.init();
    },
    init: function() {
        var self = this;
        self.$container = $('<div class="cui-modalContainer">');
        self.$container.append(self.$broken);
        self.$container.append(self.$el);
        $('body').append(self.$container);

        self.setPosition();
        self.watch();
    },
    watch: function() {
        var self = this;
        var close = self.$el.find('.cui-modal-close');
        if (close) {
            close.on('click', function() {
                self.close();
            });

            self.$broken.on('click', function() {
                self.close();
            });

        } else {
            self.$el.parent().on('click', function() {
                self.close();
            });
        }

        $(window).on('resize', function() {
            if (self.isShow) {
                self.setPosition();
                // self.setSize();
            }
        })
    },
    open: function() {
        var self = this;
        self.isShow = true;
        if (self.$container) {
            self.$el.show();
            self.$container.fadeIn(300);
            self.setPosition();
        }
    },
    close: function() {
        var self = this;
        self.isShow = false;
        if (self.$container) {
            self.$container.fadeOut(300);
            self.emit('modalClose');
        }
    },
    setPosition: function() {
            var self = this;
            var left = ($(window).width() - self.$el.width()) / 2;
            var top = ($(window).height() - self.$el.height()) / 2;
            self.$el.css({
                position: 'absolute',
                left: left + 'px',
                top: top + 'px'
            });
        }
        // setSize: function(w, h) {
        //
        // }
});

module.exports = modal;
