/**
 * @Author: vegawong
 * @Date:   2016-02-20T14:52:43+08:00
* @Last modified by:   vegawong
* @Last modified time: 2016-02-20T15:27:53+08:00
 */



/*
    面板
*/
'use strict';

require('./style.less');

var $ = require('jquery');
var stapes = require('stapes');

var tpl = [
    '<div class="cui-panelContainer">' +
    '<div class="cui-panel-header">' +
    '<i class="cpf-icon-thin-close cui-modal-close"></i>' +
    '</div>' +
    '<div class="cui-panel-content"></div>' +
    '</div>'
].join('');

var panel = stapes.subclass({
    constructor: function($title, $el) {
        var self = this;
        if (typeof $title == 'string') {
            self.$title = $('<span>' + $title + '</span>')
        } else {
            self.$title = $title;
        }
        self.$el = $el;
        self.$tpl = $(tpl);

        self.init();
    },
    init: function() {
        var self = this;
        self.$tpl.find('.cui-panel-header').append(self.$title);
        self.$tpl.find('.cui-panel-content').append(self.$el);

        self.watch();
    },
    watch: function() {
        var self = this;

        self.$tpl.on('click', function(e) {
            e.stopPropagation();
        });

        self.$tpl.find('.cui-panel-header i').on('click', function() {
            self.$tpl.hide();
        });
    },
    getPanel: function() {
        var self = this;
        return self.$tpl;
    },
    setSize: function(w, h) {
        var self = this;
        self.$tpl.css({
            width: w || 'auto',
            height: h || 'auto'
        })
        self.emit('resize');
    }
});

module.exports = panel;
