/*
 * @Author: acer
 * @Date:   2015-12-21 17:00:21
 * @Last modified by:   Jet.Chan
 * @Last modified time: 2017-03-07T18:28:09+08:00
 */

'use strict';

require('./style.less');

var $ = require('jquery');
var stapes = require('stapes');

var tpl = [
    '<div class="ie-placeholder">' +
    '</div>'
].join('');

var placeholder = stapes.subclass({
    constructor: function($el) {
        var self = this;
        if (!$el) {
            return;
        }
        self.$el = $el;
        self.$tpl = $(tpl);
        self.placeholder = self.$el.attr('placeholder');

        self.init();
    },
    init: function() {
        var self = this;
        var left = 12;
        var top = 6;

        if (self.$el.siblings().hasClass('addonLeft')) {
            left = left + self.$el.siblings().filter('.addonLeft').outerWidth();
        }

        self.$tpl.css({
            left: left,
            top: top
        });

        self.$tpl.text(self.placeholder);
        self.$tpl.insertAfter(self.$el);

        self.watch();
    },
    watch: function() {
        var self = this;
        var ph = self.$el.parent().find('.ie-placeholder');
        ph.on('click', function() {
            if (!self.$el.attr('disabled')) {
                self.$el.focus();
            }
        });

        self.$el.on('keyup', function() {
                if ($(this).val() !== '') {
                    ph.hide();
                } else {
                    ph.show();
                }
            })
            .on('blur', function() {
                if ($(this).val() === '') {
                    ph.show();
                }
            });

        self.$el.on('propertychange', function() {
            if ($(this).val() !== '') {
                ph.hide();
            } else {
                ph.show();
            }
        });

        if (self.$el.val() !== '') {
            ph.hide();
        }
    }
});

module.exports = placeholder;
