/*
 * @Author: vegawong
 * @Date:   2015-12-17 16:27:55
* @Last modified by:   Jet.Chan
* @Last modified time: 2017-03-16T18:00:06+08:00
 */

'use strict';
var $ = require('jquery'),
    stapes = require('stapes');

//style
require('./style.less');

var tpl = [
    '<div class="cui-popTips">' +
    '<div class="cui-popTips-con">' +
    '<i class=""/>' +
    '<div class="cui-popTips-text">Success</div>' +
    '</div>' +
    '</div>'
].join('');

var tplForCommon = [
    '<div class="cui-popTips">' +
    '<div class="cui-popTips-con">' +
    '<div class="iconType"><span><i class=""/><span></div>' +
    '<div class="cui-popTips-text">commonTips</div>' +
    '</div>' +
    '</div>'
].join('');

var popTips = stapes.subclass({
    constructor: function() {
        var self = this;
        self.$con = $('body');
        self.options = {
            hideDelay: 2500
        };
    },
    success: function(content, delay) {
        var self = this;
        self.show(content || 'Success', delay);
        self.resetPosition();
        self.$el.removeClass('warn');
        self.$el.removeClass('error');
        self.$el.addClass('success');
        self.$el.find('i').attr('class', 'cpf-icon-ic_tick');
        self.resetPosition();
    },
    warn: function(content, delay) {
        var self = this;
        self.show(content || 'Warning', delay);
        self.resetPosition();
        self.$el.removeClass('success');
        self.$el.removeClass('error');
        self.$el.addClass('warn');
        self.$el.find('i').attr('class', 'cpf-icon-ic_warming');
        self.resetPosition();
    },
    error: function(content, delay) {
        var self = this;
        self.show(content || 'Error', delay);
        self.resetPosition();
        self.$el.removeClass('warn');
        self.$el.removeClass('success');
        self.$el.addClass('error');
        self.$el.find('i').attr('class', 'cpf-icon-ic_close');
        self.resetPosition();
    },
    errorTip: function(content, delay){
        var self = this;
        self.commonShow(content || 'errorTip', delay);
        // self.resetPosition();
        self.$el.removeClass('warnTip,successTip,errorTip');
        self.$el.addClass('errorTip');
        self.$el.find('div i').attr('class', 'cpf-icon-thin-close');
        self.resetPosition();
        self.$el.css({
            left:'50%'
        })
    },
    successTip: function(content, delay) {
        var self = this;
        self.commonShow(content || 'successTip', delay);
        // self.resetPosition();
        self.$el.removeClass('warnTip,errorTip,successTip');
        self.$el.addClass('successTip');
        self.$el.find('div i').attr('class', 'cpf-icon-ic_tick');
        self.resetPosition();
        self.$el.css({
            left:'50%'
        })
    },
    warnTip: function(content, delay) {
        var self = this;
        self.commonShow(content || 'warnTip', delay);
        self.$el.removeClass('successTip,errorTip,warnTip');
        self.$el.addClass('warnTip');
        self.$el.find('div i').attr('class', 'cpf-icon-ic_warm');
        self.resetPosition();
        self.$el.css({
            left:'50%'
        })
    },
    show: function(content, delay) {
        var self = this;
        if ($('.cui-popTips').length <= 0 || !self.$el) {
            self.$el = $(tpl);
            self.$con.append(self.$el);
        }
        self.$el.find('.cui-popTips-text').text(content);
        self.$el.show();
        if (self.timeOutObj) {
            clearTimeout(self.timeOutObj);
        }
        self.timeOutObj = setTimeout(function() {
            self.hide();
        }, delay || self.options.hideDelay);
    },
    commonShow: function(content, delay){
        var self = this;
        if ($('.cui-popTips').length <= 0 || !self.$el) {
            self.$el = $(tplForCommon);
            self.$con.append(self.$el);
        }
        self.$el.find('.cui-popTips-text').text(content);
        self.$el.show();
        if (self.timeOutObj) {
            clearTimeout(self.timeOutObj);
        }
        self.timeOutObj = setTimeout(function() {
            self.hide();
        }, delay || self.options.hideDelay);
    },
    hide: function() {
        //  var self = this;
        $('.cui-popTips').hide();
        $('.cui-popTips').remove();

    },
    resetPosition: function() {
        var self = this;
        self.$el.css({
            'margin-left': -1 * self.$el.width() / 2,
            'margin-top': -1 * self.$el.height() / 2
        });
    }
});


module.exports = new popTips();
