/*
    输入框
*/
'use strict';

require('./style.less');

var $ = require('jquery');
var stapes = require('stapes');
var util = require('../../../lib/util');
var placeholder = require('../placeholder/index');
var validator = require('../validator/index');
var validTips = require('../validTips/index');

/*$(function() {
    if (util.ie <= 8) {
        var placeholders = [];
        var inputElements = $('div.cui-textBoxContainer input, div.cui-textBoxContainer textarea');
        inputElements.map(function(i, v) {
            var placeholderInstance = new placeholder($(v));
            placeholders.push(placeholderInstance);
        }, this);
    }

    $('div.cui-textBoxContainer input, div.cui-textBoxContainer textarea').on('focus', function() {
            $(this).removeClass('success failure hold');
            $(this).addClass('hold');
        })
        .on('blur', function() {
            $(this).removeClass('success failure hold');

            var rule = $(this).parent().attr('data-rule');

            if (rule) {
                if (validator.validate(rule, $(this))) {
                    $(this).addClass('success');
                } else {
                    $(this).addClass('failure');
                }

                if (!rule.match('required') && $(this).val() === '') {
                    $(this).removeClass('success failure hold');
                }
            }
        });
});

module.exports = {
    getValue: function(ref) {
        var textBox = $('div.cui-textBoxContainer[data-ref=' + ref + ']');
        return textBox.find('input, textarea').val();
    },
    setValue: function(ref, val) {
        var textBox = $('div.cui-textBoxContainer[data-ref=' + ref + ']');
        textBox.find('input, textarea').val(val);
    },
    validtate: function(ref) {
        var input = $('div.cui-textBoxContainer[data-ref=' + ref + ']').find('input');
        return validator.validate(rule, input);
    }
};*/


var textBox = stapes.subclass({
    constructor: function($el) {
        var self = this;
        if (!$el) {
            return;
        }
        self.$el = $el;
        self.init();
    },
    init: function() {
        var self = this;

        var placeholders = [];
        if (util.ie <= 9) {
            var inputElement = self.$el.find('input, textarea');
            var placeholderInstance = new placeholder(inputElement);
        }
        placeholders.push(placeholderInstance);

        self.watch();
    },
    watch: function() {
        var self = this;

        self.$el.find('input, textarea').on('focus', function() {
                self.clearValidate();
                $(this).addClass('hold');
            })
            .on('blur', function() {
                self.clearValidate();

                var rule = $(this).parent().data('rule');

                if (rule) {
                    if (validator.validate(rule, $(this)).val) {
                        self.setValidate(true);
                    } else {
                        self.setValidate(false, self.$el.data('tips') || validator.validate(rule, $(this)).tip);
                    }

                    if (!rule.match('required') && $(this).val() === '') {
                        self.clearValidate();
                    }
                }
            });
    },
    getValue: function() {
        var self = this;
        return self.$el.find('input, textarea').val();
    },
    setValue: function(val) {
        var self = this;
        self.$el.find('input, textarea').val(val);
    },
    getValidate: function() {
        var self = this;
        var rule = self.$el.data('rule');
        var inputElement = self.$el.find('input, textarea');
        if (validator.validate(rule, inputElement).val) {
            return true;
        } else if (!rule.match('required') && inputElement.val() === '') {
            return true;
        } else {
            return false;
        }
    },
    setValidate: function(validate, tips) {
        var self = this;

        self.clearValidate();

        if (validate) {
            self.$el.find('input, textarea').addClass('success');
        } else {
            self.$el.find('input, textarea').addClass('failure');
            var inputElement = self.$el.find('input, textarea');
            var validTipsInstance = new validTips(inputElement, tips);
            validTipsInstance.show();
        }
    },
    clearValidate: function() {
        var self = this;
        self.$el.find('input, textarea').removeClass('success failure hold');
        self.$el.find('.valid-tips').remove();
    }
});

module.exports = textBox;
