/*
    切换开关
*/
'use strict';

require('./style.less');

var $ = require('jquery');
var stapes = require('stapes');

/*$(function() {
    var toggleBoxes = $('div.cui-toggle-box-component');
    toggleBoxes.map(function(i, v) {
        var val;
        $(v).attr('class').split(' ').forEach(function(classname) {
            val = classname.match('^on$|^off$');
        });
        $(v).attr('data-val', val);
    }, this);

    toggleBoxes.on('click', function() {
        var val = $(this).attr('data-val') === 'on' ? 'off' : 'on';
        $(this).attr('data-val', val);

        $(this).toggleClass('on');
        $(this).toggleClass('off');

        $(this).find('.icon-component').toggleClass('cpf-icon-ic_tick');
        $(this).find('.icon-component').toggleClass('cpf-icon-ic_close');
    });
});

module.exports = {
    getValue: function(ref) {
        var toggleBox = $('div.cui-toggle-box-component[data-ref=' + ref + ']');
        var val = toggleBox.attr('data-val') === 'on' ? true : false;
        return val;
    },
    setValue: function(ref, val) {
        var toggleBox = $('div.cui-toggle-box-component[data-ref=' + ref + ']');
        var value = toggleBox.attr('data-val') === 'on' ? true : false;
        if (value !== val) {
            toggleBox.click();
        }
    }
};*/

var toggleBox = stapes.subclass({
    constructor: function($el) {
        var self = this;

        if (!$el) {
            return;
        }

        self.$el = $el;
        self.val = true;

        self.init();
    },
    init: function() {
        var self = this;

        self.$el.attr('class').split(' ').forEach(function(classname) {
            var value = classname.match('^on$|^off$');
            self.val = value == 'on' ? true : false;
        });

        self.watch();
    },
    watch: function() {
        var self = this;

        self.$el.on('click', function() {
            self.val = !self.val;

            $(this).toggleClass('on');
            $(this).toggleClass('off');

            $(this).find('.icon-component').toggleClass('cpf-icon-ic_tick');
            $(this).find('.icon-component').toggleClass('cpf-icon-ic_close');
        });
    },
    getValue: function() {
        var self = this;

        return self.val;
    },
    setValue: function(val) {
        var self = this;

        self.val = val;

        if (self.val) {
            self.$el.addClass('on');
            self.$el.removeClass('off');

            self.$el.find('.icon-component').addClass('cpf-icon-ic_tick');
            self.$el.find('.icon-component').removeClass('cpf-icon-ic_close');
        } else {
            self.$el.addClass('off');
            self.$el.removeClass('on');

            self.$el.find('.icon-component').addClass('cpf-icon-ic_close');
            self.$el.find('.icon-component').removeClass('cpf-icon-ic_tick');
        }
    }
});

module.exports = toggleBox;
