/*
 * @Author: vegawong
 * @Date:   2015-12-18 15:25:13
 * @Last Modified by:   vegawong
 * @Last Modified time: 2015-12-18 19:30:40
 */

'use strict';

var $ = require('jquery');

//boostrap tooltips jquery-plugin
require('./bootstrap-tooltip');

//style
require('./style.less');


/**
 * tooTip plugin
 * @param  {object | string} selector jquery object or selector string
 * @param  {object} options  see the bootstrap api
 * @return {[type]}          [description]
 */
var toolTip = function(selector, options) {
    this.options = $.extend(toolTip.defaultOpt, options || {});
    if (typeof selector === 'object') {
        selector.tooltip(this.options);
    } else if (typeof selector === 'string') {
        $(selector).tooltip(this.options);
    }
};

toolTip.defaultOpt = {
    template: '<div class="cui-tooltip" role="cui-tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>'
};


module.exports = toolTip;
