/*
 * @Author: acer
 * @Date:   2015-12-21 17:00:21
 * @Last Modified by:   dser.wei
 * @Last Modified time: 2016-01-15 15:28:47
 */

'use strict';

require('./style.less');

var $ = require('jquery');
var stapes = require('stapes');

var tpl = [
    '<div class="valid-tips">' +
    '<div class="valid-tips-arrow"></div>' +
    '<div class="valid-tips-inner"></div>' +
    '</div>'
].join('');

var validTips = stapes.subclass({
    constructor: function($el, tips) {
        var self = this;
        if (!$el || !tips) {
            return;
        }
        self.$el = $el;
        self.$tpl = $(tpl);
        self.validTips = tips;
        self.timeout = null;

        self.init();
    },
    init: function() {
        var self = this;
        var top = self.$el.outerHeight() + 5;
        var width = self.$el.outerWidth();
        self.$tpl.css({
            top: top,
            maxWidth: width
        });

        self.$tpl.find('.valid-tips-inner').text(self.validTips);
        self.$tpl.insertAfter(self.$el);

        self.watch();
    },
    watch: function() {
        var self = this;

        self.$el.on('focus', function() {
            self.hide();
        });
    },
    show: function() {
        var self = this;
        if (self.$tpl) {
            self.$tpl.fadeIn(200);
            clearTimeout(self.timeout);
            self.timeout = setTimeout(function() {
                self.$tpl.fadeOut(200);
            }, 1200);
        }
    },
    hide: function() {
        var self = this;
        if (self.$tpl) {
            self.$tpl.fadeOut(200);
        }
    }
});

module.exports = validTips;
